//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void ICACHE_FLASH_ATTR checkandbuildindex(void) {
  Dir dir = SPIFFS.openDir("/");
  while (dir.next()) {
    String filename = String(dir.fileName());

    if (filename.endsWith(".txt")) {
      String indexname = filename.substring(0, filename.length() - 4) + ".idx";

      // SPIFFS.remove((char*)indexname.c_str());

      if (! SPIFFS.exists((char*)indexname.c_str())) {
        Serial.print("Create Index ");
        Serial.print(indexname);

        File indexfile = SPIFFS.open((char *)indexname.c_str(), "w");

        File f = dir.openFile("r");
        byte buffer[1024];
        long lencount = 0;
        int bufcount;
        int idxc = 0;

        do {
          bufcount = f.read(buffer, 1024);
          for (int i = 0; i < bufcount; i++) {
            if (buffer[i] == 13) {
              long index = lencount + i;
              indexfile.write((uint8_t *)&index, sizeof(index));
              idxc++;
            }
          }
          lencount += bufcount;
        } while (bufcount != 0);

        Serial.print(" ");
        Serial.print(idxc);
        Serial.print(" ");

        Serial.println();

        indexfile.close();
      }
    }
  }
}


//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
String ICACHE_FLASH_ATTR getindexhtmlpage(void) {
  String html = 
"<!DOCTYPE html><html><head><title>"+String(htmltitle)+"</title></head><body>\n\n"
"<style type=\"text/css\">\n"
".ue {display:flex;justify-content:center;}\n"
".i {position:relative;vertical-align:center;float:left;clear:none;overflow:hidden;}\n"
".i img {position:relative;z-index:1;}\n"
".i .d {display:block;position:absolute;width:100%;bottom:0px;left:0;z-index:2; text-align:center;color:white;font-family:Verdana,sans-serif;}\n"
"</style>\n\n";

  Dir dir = SPIFFS.openDir("/");
  while (dir.next()) {
    String filename = String(dir.fileName());

    if (filename.endsWith(".txt")) {
      String sloganname = filename.substring(1, filename.length() - 4);

      html+="<div class=\"ue\">\n"
            "<a href=\"/"+sloganname+"\">\n"
            "<div class=\"i\">\n"
            "<img src=\""+sloganname+".jpg\" />\n"
            "<h3 class=\"d\">"+sloganname+"</h3>\n"
            "</div></a></div>\n";     
    }
  }
  return html+"\n</body></html>\n\n";
}

//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
String getlinefromfile(String filename, int line) {
  String indexname = filename.substring(0, filename.length() - 4) + ".idx";

  File indexfile = SPIFFS.open((char *)indexname.c_str(), "r");

  // keine Zeile, also auswürfeln
  if (line == -1) {
    line = random(indexfile.size() / 4);
  }

  long start = 0;
  long ende = 0;
  int r = -1;

  while ( (line > 0) && (r != 0) ) {
    r = indexfile.read((uint8_t *)&start, sizeof(start));
    line--;
  }
  indexfile.read((uint8_t *)&ende, sizeof(ende));
  indexfile.close();

  if (line == 0) {
    /*
    Serial.print("Start: ");
    Serial.print(start);
    Serial.print(" Ende: ");
    Serial.print(ende);
    Serial.println();
    */

    String antwort;
    char buffer[128];
    int len = ende - start - 1;

    File sloganfile = SPIFFS.open((char *)filename.c_str(), "r");
    sloganfile.seek(start + 2, SeekSet);
    do {
      memset(buffer, 0, sizeof(buffer));
      int r;
      if (len > sizeof(buffer) - 1) {
        r = sloganfile.read((uint8_t *)&buffer, sizeof(buffer) - 1);
      } else
      {
        r = sloganfile.read((uint8_t *)&buffer, len);
      }
      len -= r;
      antwort = antwort + String(buffer);
    } while ( (len > 0) && (r > 0) );
    sloganfile.close();

    return antwort;
  } else {
    return "Nothing found";
  }
}
