const byte DNS_PORT = 53;
IPAddress apIP(192, 168, 1, 1);
DNSServer *dnsServer;
ESP8266WebServer *webServer;

//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void setupAsAccessPoint() {
  WiFi.mode(WIFI_AP);
  WiFi.softAPConfig(apIP, apIP, IPAddress(255, 255, 255, 0));
  WiFi.softAP(htmltitle);

  // if DNSServer is started with "*" for domain name, it will reply with
  // provided IP to all DNS request
  dnsServer = new DNSServer();
  dnsServer->start(DNS_PORT, "*", apIP);

  webServer = new ESP8266WebServer(80);
  webServer->onNotFound(WebServerHandleRequest);
  webServer->begin();
}

//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
/** IP to String? */
String toStringIp(IPAddress ip) {
  String res = "";
  for (int i = 0; i < 3; i++) {
    res += String((ip >> (8 * i)) & 0xFF) + ".";
  }
  res += String(((ip >> 8 * 3)) & 0xFF);
  return res;
}

//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void WebServerHandleRequest(void) {
  Serial.print("Request: ");
  Serial.print(toStringIp(webServer->client().localIP()));
  Serial.print(" ");
  Serial.print(webServer->uri());

  // wenn Dateiene existieren...
  if (SPIFFS.exists((char*)webServer->uri().c_str())) {
    if (webServer->uri().endsWith(".jpg")) {
      File file = SPIFFS.open((char *)webServer->uri().c_str(), "r");
      webServer->streamFile(file, "image/jpeg");
      file.close();
      Serial.print(" 200");
    } else {
      Serial.print(" 200too");
      webServer->send(200, "text/html", indexpage);
    }
  } else {
    webServer->send(200, "text/html", indexpage);

    String sloganname = webServer->uri() + ".txt";
    if (SPIFFS.exists((char*)sloganname.c_str())) {
      Serial.print(" 200 slogan");
      printerbuffer = printerbuffer + getlinefromfile(sloganname, -1) + "\n\r\n\r\n\r\n\r";
    }
  }
  Serial.println();

  return;
}

//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void loopWebServer(void) {
  if (dnsServer) {
    dnsServer->processNextRequest();
  }
  if (webServer) {
    webServer->handleClient();
  }
}

