#define debugmsgs

#include <ESP8266WiFi.h>
#include <DNSServer.h>
#include <ESP8266WebServer.h>
#include "FS.h"
#include <lpt.h>

LPT lpt;
String printerbuffer = "";

// ports depend on you personal believes...
const byte Pin595Data = 12;          //
const byte Pin595SH_CP = 15;         //
const byte Pin595ST_CP = 13;         //
const byte PinPrtStrobe = 4;         //
const byte PinPrtBusy = 5;           //

String indexpage;

#define htmltitle "SFLLUKKTUS"


//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void setup() {
  Serial.begin(115200);
  delay(1000);
  Serial.println("\nHello");

  Serial.println("Init Spiffs");
  SPIFFSInit();
  Serial.println("Check and build index");
  checkandbuildindex();
  Serial.println("Building index page");
  indexpage = getindexhtmlpage();

  Serial.println("Starting Web and DNS services");
  setupAsAccessPoint();

  randomSeed(millis());

  Serial.println("Up.");

  // Set ports
  lpt.begin(Pin595Data, Pin595ST_CP, Pin595SH_CP, PinPrtStrobe, PinPrtBusy);
}


//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
void loop() {
  loopWebServer();
  printqueueworker();
}
